#include <iostream>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <list>
#include <map>

using namespace std;


	

struct Card{
	int rank;
	char color;
};



struct Hand{
	Card cards[5];
	int type;
};

bool isFlush(Hand h){
	char color = h.cards[0].color;
	for (int i = 1; i < 5; i++){
		if (color != h.cards[i].color) return false;
	}
	return true;
}

int decFlush(Hand h1, Hand h2){
	for (int i = 4; i >= 0; i--){
		if (h1.cards[i].rank > h2.cards[i].rank) return 1;
		if (h1.cards[i].rank < h2.cards[i].rank) return -1;
	}
	return 0;
}

bool isStraight(Hand h){
	int rank = h.cards[0].rank;
	if (rank == 14) rank = 1;
	for (int i = 1; i < 5; i++){

		if (h.cards[i].rank != (rank + 1)) return false;
		rank++;
	}	
	cout << endl;
	return true;
}

int decStraight(Hand h1, Hand h2){
	if (h1.cards[2].rank > h2.cards[2].rank) return 1;
	if (h1.cards[2].rank < h2.cards[2].rank) return -1;
	return 0;
}

bool isRoyal(Hand h){
	return isFlush(h) && isStraight(h);
}
int decRoyal(Hand h1, Hand h2){
	if (h1.cards[2].rank > h2.cards[2].rank) return 1;
	if (h1.cards[2].rank < h2.cards[2].rank) return -1;
	return 0;
}

bool isPoker(Hand h){
	return (h.cards[0].rank == h.cards[3].rank || h.cards[1].rank == h.cards[4].rank);
}

int decPoker(Hand h1, Hand h2){
	if (h1.cards[2].rank > h2.cards[2].rank) return 1;
	if (h1.cards[2].rank < h2.cards[2].rank) return -1;
	return 0;
}

bool isFullHouse(Hand h){
	return ((h.cards[0].rank == h.cards[2].rank && h.cards[3].rank == h.cards[4].rank) ||
		(h.cards[0].rank == h.cards[1].rank && h.cards[2].rank == h.cards[4].rank));
}
int decFullHouse(Hand h1, Hand h2){
	if (h1.cards[2].rank > h2.cards[2].rank) return 1;
	if (h1.cards[2].rank < h2.cards[2].rank) return -1;
	int two1 = (h1.cards[2].rank == h1.cards[1].rank) ? h1.cards[4].rank : h1.cards[1].rank;
	int two2 = (h2.cards[2].rank == h2.cards[1].rank) ? h2.cards[4].rank : h2.cards[1].rank;
	if (two1 > two2) return 1;
	if (two2 > two1) return -1;
	return 0;
}



bool isThree(Hand h){
	return (h.cards[0].rank == h.cards[2].rank || h.cards[1].rank == h.cards[3].rank ||
		h.cards[2].rank == h.cards[4].rank);
}

int decThress(Hand h1, Hand h2){
	if (h1.cards[2].rank > h2.cards[2].rank) return 1;
	if (h1.cards[2].rank < h2.cards[2].rank) return -1;
	return 0;
	
}

bool isTwoPairs(Hand h){
	bool hasFirstPair = false;
	int rank = h.cards[0].rank;
	for (int i = 1; i < 5; i++){
		if (h.cards[i].rank == rank){
			if (hasFirstPair) return true;
			hasFirstPair = true;
		} else{
			rank = h.cards[i].rank;
		}	
	}
	return false;
}

int decTwoPairs(Hand h1, Hand h2){

	return 0;
}

bool isPair(Hand h){
	int rank = h.cards[0].rank;
	for (int i = 1; i < 5; i++){
		if (h.cards[i].rank == rank){
			return true;
		} else{
			rank = h.cards[i].rank;
		}	
	}
	return false;
}
int decPair(Hand h1, Hand h2){
	return 0;
}
bool isOneCard(Hand h){
	return true;
}

int decOneCard(Hand h1, Hand h2){
	for (int i = 0; i < 5; i++){
		if (h1.cards[i].rank > h2.cards[i].rank) return 1;	
		if (h1.cards[i].rank < h2.cards[i].rank) return -1;	
	}
	return 0;
}

int getHighestCard(Hand h){
	int highest = 0;
	for (int i = 0; i < 5; i++){
		if (h.cards[i].rank > highest){
			highest = h.cards[i].rank;
		}
	}
	return highest;
}

/*int countOfSameRanks(Hand h){
	int count = 1;
	int highestCount = 0;
	int card = h.cards[0].rank;
	for (int i = 1; i < 5; i++){
		if (card == h.cards[i].rank) {
			count++;
		}
		else{
			card = h.cards[i].rank;
			if (highestCount < count) highestCount = count;
			count = 1;
		}
	}
	if (highestCount < count) highestCount = count;
	return highestCount;
}*/

int parseRank(char r){
	switch (r){
		case 'X': return 10;
		case 'J': return 11;
		case 'Q': return 12;
		case 'K': return 13;
		case 'A': return 14;
		
		default: return (int) r - 48;
	}

}

Card parseCard(string s){
	Card c;
	c.rank = parseRank(s[0]);
	c.color = s[1];
	return c;
}

int N;
Card sharedCards[5];

bool cmp(const Card &a, const Card &b){
	return a.rank < b.rank;
}

Hand getHand(Card c1, Card c2, Card c3, Card c4, Card c5){
	Hand h;
	h.cards[0] = c1;
	h.cards[1] = c2;
	h.cards[2] = c3;
	h.cards[3] = c4;
	h.cards[4] = c5;
	//seradit
	sort(h.cards, h.cards + 5, cmp);
	return h;
}

int getHandType(Hand h){
	if (isRoyal(h)) return 9;
	if (isPoker(h)) return 8;
	if (isFullHouse(h)) return 7;
	if (isFlush(h)) return 6;
	if (isStraight(h)) return 5;
	if (isThree(h)) return 4;
	if (isTwoPairs(h)) return 3;
	if (isPair(h)) return 2;
	return 1;
}


Hand getBestPlayerHand(Card c1, Card c2){
	Hand hands[21];
	hands[0] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], sharedCards[3], sharedCards[4]);

	hands[1] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], sharedCards[3], c1);
	hands[2] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], sharedCards[4], c1);
	hands[3] = getHand(sharedCards[0], sharedCards[1], sharedCards[3], sharedCards[4], c1);
	hands[4] = getHand(sharedCards[0], sharedCards[2], sharedCards[3], sharedCards[4], c1);
	hands[5] = getHand(sharedCards[1], sharedCards[2], sharedCards[3], sharedCards[4], c1);
	hands[6] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], sharedCards[3], c2);
	hands[7] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], sharedCards[4], c2);
	hands[8] = getHand(sharedCards[0], sharedCards[1], sharedCards[3], sharedCards[4], c2);
	hands[9] = getHand(sharedCards[0], sharedCards[2], sharedCards[3], sharedCards[4], c2);
	hands[10] = getHand(sharedCards[1], sharedCards[2], sharedCards[3], sharedCards[4], c2);
	hands[11] = getHand(sharedCards[0], sharedCards[1], sharedCards[2], c1, c2);
	hands[12] = getHand(sharedCards[0], sharedCards[1], sharedCards[3], c1, c2);
	hands[13] = getHand(sharedCards[0], sharedCards[1], sharedCards[4], c1, c2);
	hands[14] = getHand(sharedCards[0], sharedCards[2], sharedCards[3], c1, c2);
	hands[15] = getHand(sharedCards[0], sharedCards[2], sharedCards[4], c1, c2);
	hands[16] = getHand(sharedCards[0], sharedCards[3], sharedCards[4], c1, c2);
	hands[17] = getHand(sharedCards[1], sharedCards[2], sharedCards[3], c1, c2);
	hands[18] = getHand(sharedCards[1], sharedCards[2], sharedCards[4], c1, c2);
	hands[19] = getHand(sharedCards[1], sharedCards[3], sharedCards[4], c1, c2);
	hands[20] = getHand(sharedCards[2], sharedCards[3], sharedCards[4], c1, c2);
	
	int bestHand = -1;
	int bestHandIndex = 0;
	
	for (int i = 0; i < 21; i++){
		int type = getHandType(hands[i]);

		if (bestHand < type){
			bestHand = type;
			bestHandIndex = i;
		}
		if (bestHand == type){
			int c;
			switch (type){
				case 1: c = decOneCard(hands[bestHandIndex], hands[i]);break;
				case 2: c = decPair(hands[bestHandIndex], hands[i]);break;
				case 3: c = decTwoPairs(hands[bestHandIndex], hands[i]);break;
				case 4: c = decThree(hands[bestHandIndex], hands[i]);break;
				case 5: c = decStraight(hands[bestHandIndex], hands[i]);break;
				case 6: c = decFlush(hands[bestHandIndex], hands[i]); break;
				case 7: c = decFullHouse(hands[bestHandIndex], hands[i]);break;
				case 8: c = decPoker(hands[bestHandIndex], hands[i]);break;
				case 9: c = decRoyal(hands[bestHandIndex], hands[i]);break;
			}
			if (c < 0) {
				bestHandIndex = i;
			}
		}
	}
	hands[bestHandIndex].type = bestHand;
	return hands[bestHandIndex];
}


int main(){
	
	while (cin >> N){
		for (int i = 0; i < 5; i++){
			string s;
			cin >> s;

			sharedCards[i] = parseCard(s);
		}
		
		int best = 1;
		
		for (int i = 1; i <= N; i++){
			string s1;
			string s2;
			cin >> s1 >> s2;
			Card c1 = parseCard(s1);
			Card c2 = parseCard(s2);
			
			Hand h = getBestPlayerHand(c1, c2);
			int type = getHandType(hands[i]);
			
		}
	
	}	
	
	
	
}
